program MathGLChapter2_5;

uses
  Math,
  mgl_pas;

function sample(gr: HMGL; P: Pointer): integer; cdecl;
var
  a: HMDT;
begin
  //gr = mgl_create_graph_zb(600, 400);
  //mgl_set_alpha(gr, 1);
  //mgl_set_light(gr, 1);
  a := mgl_create_data_size(30,20,1);
  mgl_data_modify(a,'0.6*sin(2*pi*x)*sin(3*pi*y) + 0.4*cos(3*pi*(x*y))',0);

  mgl_subplot(gr, 2, 2, 0, NIL);
  mgl_rotate(gr, 40,60,0);
  mgl_surf(gr, a, 'BbcyrR#', NIL);
  mgl_box(gr);
  mgl_subplot(gr, 2, 2, 1, NIL);
  mgl_rotate(gr, 40,60,0);
  mgl_dens(gr, a,'BbcyrR#', NIL);
  mgl_box(gr);
  mgl_subplot(gr, 2, 2, 2, NIL);
  mgl_rotate(gr, 40, 60, 0);
  mgl_cont(gr, a, 'BbcyrR#', NIL);
  mgl_box(gr);
  mgl_subplot(gr, 2, 2, 3, NIL);
  mgl_rotate(gr, 40, 60, 0);
  mgl_axial(gr, a, 'BbcyrR#', NIL);
  mgl_box(gr);
  mgl_write_png(gr, 'MathGLChapter2_5.bmp', NIL);
  mgl_write_png(gr, 'MathGLChapter2_5.png', NIL);
  mgl_write_png(gr, 'MathGLChapter2_5.svg', NIL);
  sample := 0;
end;

procedure main;
var
  gr:       HMGL;
  DrawFunc: TMglDrawFunction;

begin
  DrawFunc := @sample;
  gr := mgl_create_graph_fltk(DrawFunc, 'MathGL example chapter 2.5', NIL);
  mgl_fltk_run();
  //gr := mgl_create_graph_qt(DrawFunc, 'MathGL example chapter 2.5', NIL);
  //mgl_qt_run();
  //gr := mgl_create_graph_glut(DrawFunc, 'MathGL example chapter 2.5', NIL);
  mgl_delete_graph(gr);
end;

begin
  SetExceptionMask([exDenormalized, exInvalidOp, exOverflow, exPrecision, exUnderflow, exZeroDivide]);
  main;
end.


